function [ Ys_fixed_X ] = constr_backbend_cell_interpols(X_cell,Y_cell,X_fix,max_card)

% initialize output
Ys_fixed_X = cell(0,4);

equilib2ap_unique = zeros(size(X_cell,1),1) > 1;
equilib2ap_multip = zeros(size(X_cell,1),1) > 1;
for iap = 1:size(X_cell,1);
    if size(X_cell{iap},2) == 1;
       if ~isnan(X_cell{iap});
           equilib2ap_unique(iap) = true;       
       end;
    end;
    if size(X_cell{iap},2) > 1;
       if any(~isnan(X_cell{iap}));
           equilib2ap_multip(iap) = true;       
       end;
    end; 
end;

x_vals_curve = [];
y_vals_curve = [];
for iap = 1:size(X_cell,1);
    if equilib2ap_unique(iap)
        x_vals_curve = [x_vals_curve;X_cell{iap}];
        y_vals_curve = [y_vals_curve;Y_cell{iap}];
    end;
    if iap < size(X_cell,1);
        if equilib2ap_unique(iap) && ~equilib2ap_unique(iap+1);
            temp1 = interpcurve2(x_vals_curve,y_vals_curve,X_fix,max_card);
            numb_intersect = sum(~isnan(temp1));
            for i_backbend = 1:numb_intersect;
                y_fixed_X_add = cell(1,4);
                y_fixed_X_add{1} = X_fix;
                y_fixed_X_add{2} = temp1(i_backbend);
                y_fixed_X_add{3} = 'unique';
                y_fixed_X_add{4} = 'constrained';
                Ys_fixed_X = [Ys_fixed_X;y_fixed_X_add];
            end
            x_vals_curve = [];
            y_vals_curve = [];
        end;
    else
        if size(x_vals_curve,1) > 0;
            temp1 = interpcurve2(x_vals_curve,y_vals_curve,X_fix,max_card);
            numb_intersect = sum(~isnan(temp1));
            for i_backbend = 1:numb_intersect;
                y_fixed_X_add = cell(1,4);
                y_fixed_X_add{1} = X_fix;
                y_fixed_X_add{2} = temp1(i_backbend);
                y_fixed_X_add{3} = 'unique';
                y_fixed_X_add{4} = 'constrained';
                Ys_fixed_X = [Ys_fixed_X;y_fixed_X_add];
            end
            x_vals_curve = [];
            y_vals_curve = [];
        end;
    end;
end;

for iap = 1:size(X_cell,1);
    if equilib2ap_multip(iap)
        y_fixed_X_add = cell(1,4);
        y_fixed_X_add{1} = X_fix;
        y_fixed_X_add{2} = interp1(X_cell{iap},Y_cell{iap},X_fix);
        y_fixed_X_add{3} = 'multip';
        y_fixed_X_add{4} = 'constrained';
        Ys_fixed_X = [Ys_fixed_X;y_fixed_X_add];
    end;
end;

end

