function y_vals = interpconnected(x,y,indices_x_y,xi)
% Interpolation subject to the condition that
% xi is bracketed by values of x, which satisfy
% the property that they carry consecutive indices,
% as supplied by a separate vector of indices conforming to x and y

y_vals = NaN*zeros(1,length(xi));

for i = 1:length(xi);
        
    for j = 1:length(x)-1;
        
        if (x(j) <= xi(i) && x(j+1) > xi(i)) || (x(j) > xi(i) && x(j+1) <= xi(i));
            
            if abs(indices_x_y(j) - indices_x_y(j+1)) <= 1.1;
                      
            y_vals(i) = ( xi(i) - x(j))/(x(j+1) - x(j))*( y(j+1) - y(j)) + y(j); 
                        
            end;
                        
        end;          
        
    end;

end

