function y_vals = interpcurve10(x,y,xi,max_card)
% Interpolation on a not necessarily one-to-one curve
% Important: inputs are ordered by movement along the curve,
% i.e., successive points from the input are neighboring points on the curve.

y_vals = NaN*zeros(length(xi),max_card);

for i = 1:length(xi);
    
    numb_hits = 0;
    
    for j = 1:length(x)-1;
        
        if (x(j) <= xi(i) && x(j+1) > xi(i)) || (x(j) > xi(i) && x(j+1) <= xi(i));
            
            numb_hits = numb_hits + 1;
            
            y_vals(i,numb_hits) = ( xi(i) - x(j))/(x(j+1) - x(j))*( y(j+1) - y(j)) + y(j);            
                        
        end;          
        
    end;

end

